package me.km;

import me.km.blocks.ModBlocks;
import me.km.fluids.ModFluids;
import me.km.items.ModItems;
import me.km.recipes.ModRecipes;
import net.minecraft.block.Block;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.crafting.IRecipe;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

@Mod.EventBusSubscriber
public class ObjectRegistry 
{
    @SubscribeEvent
    public static void onBlockRegistry(RegistryEvent.Register<Block> e) 
    {
        ModFluids.init();
        ModBlocks.initBlocks(e.getRegistry());
    }
    
    @SubscribeEvent
    public static void onBlockMissing(RegistryEvent.MissingMappings<Block> e) 
    {
        e.getMappings().stream()
                .forEach((missing) -> 
                {
                    missing.remap(Blocks.STONE);   
                });
    }
    
    @SubscribeEvent
    public static void onItemMissing(RegistryEvent.MissingMappings<Item> e) 
    {
        e.getMappings().stream()
                .forEach((missing) -> 
                {
                    missing.remap(Items.APPLE);   
                });
    }

    @SubscribeEvent
    public static void onItemRegistry(RegistryEvent.Register<Item> e) 
    {
        ModItems.init(e.getRegistry());
        ModBlocks.initItemBlocks(e.getRegistry());
    }
    
    @SubscribeEvent
    public static void onRecipeRegistry(RegistryEvent.Register<IRecipe> e) 
    {
        ModRecipes.init(e.getRegistry());
    }
}
