package me.km.datatools;

import me.km.module.Module;
import me.km.module.ModuleListener;
import me.km.inventory.CustomContainer;
import me.km.inventory.InventoryBase;
import me.km.inventory.InventoryUtils;
import me.km.utils.ReflectionUtils;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.inventory.ContainerChest;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.village.MerchantRecipe;
import net.minecraft.village.MerchantRecipeList;
import net.minecraftforge.event.entity.living.LivingAttackEvent;
import net.minecraftforge.event.entity.player.PlayerContainerEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class DataToolsEvents
{
    private final Module m;
    
    public DataToolsEvents(Module m)
    {
        this.m = m;
    }
    
    @SubscribeEvent
    public void onVillagerMenuClose(PlayerContainerEvent.Close e)
    {             
        if(e.getContainer() instanceof CustomContainer)
        {
            CustomContainer c = (CustomContainer) e.getContainer();
            InventoryBase inv = c.getInventoryBase();
            if(inv.getName().startsWith("ChangeTrades"))
            {
                EntityVillager v = (EntityVillager) inv.getOwner();
                ReflectionUtils.setCareerLevel(v, 10);
                MerchantRecipeList list = v.getRecipes(null);
                if(list == null)
                {
                    return; // will never happen
                }
                else
                {
                    list.clear();
                }
                MerchantRecipe mr;
                for(int i = 0; i < 36; i++)
                {
                    if(i == 9)
                    {
                        i = 27;
                    }
                    if(inv.getStackInSlot(i) == ItemStack.EMPTY)
                    {
                        continue;                
                    }          

                    mr = new MerchantRecipe(inv.getStackInSlot(i + 9), inv.getStackInSlot(i + 18), inv.getStackInSlot(i), 0, Integer.MAX_VALUE);
                    list.add(mr);
                }
                m.send(e.getEntityPlayer(), "The villager deals were overwritten.");
            }
        }
        else if(e.getContainer() instanceof ContainerChest)
        {
            ContainerChest c = (ContainerChest) e.getContainer();
            IInventory inv = c.getLowerChestInventory();
            if(inv.getName().startsWith("ChangeInventory") && inv instanceof InventoryBase)
            {
                InventoryUtils.setInventory((InventoryBase) inv);
                m.send(e.getEntityPlayer(), "The villager inventory was overwritten.");
            }
        }
    }
    
    @SubscribeEvent
    public void VillagerProtect(LivingAttackEvent e)
    { 
        if(e.getEntityLiving() instanceof EntityVillager && !e.getSource().isCreativePlayer())
        {
            e.setCanceled(true);
        }
    }
}
