package me.km.snuviscript;

import java.util.Arrays;
import me.km.KajetansMod;
import me.km.module.Module;
import me.km.module.ModuleCommand;
import java.util.Collection;
import me.hammerle.snuviscript.code.Script;
import me.hammerle.snuviscript.variable.Variable;
import me.km.utils.Utils;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;

public class CommandScript extends ModuleCommand
{
    public CommandScript(Module m) 
    {
        super("script", m);
        super.setDescription("Zeigt alles über Scripts");
        super.setUsage("/script für die Hilfe");
        super.setPermission(Permissions.SCRIPT);
        super.addAlias("s");
    }

    @SuppressWarnings("unchecked")
    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        Module m = this.getModule();
        if(arg.length >= 1)
        {
            switch(arg[0].toLowerCase())
            {
                case "s":
                case "start":
                {
                    if(arg.length >= 2)
                    {
                        String[] pars = Arrays.copyOfRange(arg, 1, arg.length);
                        KajetansMod.scripts.startScript(pars);
                        return true;
                    }
                    break;
                }
                case "startp":
                {
                    if(arg.length >= 3)
                    {
                        try
                        {
                            EntityPlayer p = Utils.getPlayerByName(arg[1]);
                            String[] pars = Arrays.copyOfRange(arg, 2, arg.length);
                            KajetansMod.scripts.startPlayerScript(p, pars);
                        }
                        catch(PlayerNotFoundException ex)
                        {
                            m.send(cs, "Cannot find player '" + arg[1] + "'.");
                        }
                        return true;
                    }
                    break;
                }
                case "v":
                case "variable":    
                {
                    if(arg.length >= 3)
                    {
                        try
                        {
                            Script sc = KajetansMod.scripts.getSnuviParser().getScript(Integer.parseInt(arg[1]));
                            if(sc == null)
                            {
                                throw new NumberFormatException();
                            }
                            Variable var = sc.getVar(arg[2]);
                            if(var != null)
                            {
                                m.send(cs, arg[2] + " = " + var.get(sc));
                            }
                            else
                            {
                                m.send(cs, arg[2] + " = null");
                            }
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.");
                        }
                        return true;
                    }
                    break;
                }
                case "n":
                case "next":
                {
                    if(arg.length >= 2)
                    {
                        try
                        {
                            Script sc = KajetansMod.scripts.getSnuviParser().getScript(Integer.parseInt(arg[1]));
                            if(sc == null)
                            {
                                throw new NumberFormatException();
                            }
                            sc.run();
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.");
                        } 
                        return true;
                    }
                    break;
                }
                /*case "c":
                case "code":
                {
                    if(arg.length >= 3)
                    {
                        try
                        {
                            Script qd = KajetansMod.scripts.getSnuviParser().getScript(Integer.parseInt(arg[1]));
                            if(qd == null)
                            {
                                throw new NumberFormatException();
                            }
                            qd.runCodeLine(ChatManager.colorMessage(Utils.connectSpaces(arg, 2), cs), cs);
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.");
                        } 
                        return true;
                    }
                    break;
                }*/
                /*case "p":
                case "printvars":
                {
                    if(arg.length >= 2)
                    {
                        try
                        {
                            Script qd = KajetansMod.scripts.getSnuviParser().getScript(Integer.parseInt(arg[1]));
                            if(qd == null)
                            {
                                throw new NumberFormatException();
                            }
                            cs.sendMessage(new TextComponentString(GlobalText.Spacer()));
                            qd.getVars().entrySet().stream().filter(e -> arg.length < 3 || 
                                (e.getKey().startsWith(arg[2]))).forEach(e -> 
                            {
                                m.send(cs, e.getKey() + " = " + e.getValue());
                            }); 
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.");
                        } 
                        return true;
                    }
                    break;
                }*/
                /*case "pl":
                case "printlists":
                {
                    if(arg.length >= 2)
                    {
                        try
                        {
                            Script qd = KajetansMod.scripts.getSnuviParser().getScript(Integer.parseInt(arg[1]));
                            if(qd == null)
                            {
                                throw new NumberFormatException();
                            }
                            cs.sendMessage(new TextComponentString(GlobalText.Spacer()));
                            qd.getVars().entrySet().stream()
                                    .filter(e -> e.getValue() instanceof List)
                                    .filter(e -> arg.length < 3 || (e.getKey().startsWith(arg[2]))).forEach(e -> 
                            {
                                m.send(cs, e.getKey());
                                ((List<Object>) e.getValue()).forEach(l -> m.sendListElement(cs, l.toString()));
                            });   
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.");
                        }
                        return true;
                    }
                    break;
                }*/
                /*case "pm":
                case "printmaps":
                {
                    if(arg.length >= 2)
                    {
                        try
                        {
                            Script qd = KajetansMod.scripts.getSnuviParser().getScript(Integer.parseInt(arg[1]));
                            if(qd == null)
                            {
                                throw new NumberFormatException();
                            }
                            cs.sendMessage(new TextComponentString(GlobalText.Spacer()));
                            qd.getVars().entrySet().stream()
                                    .filter(e -> e.getValue() instanceof Map)
                                    .filter(e -> arg.length < 3 || (e.getKey().startsWith(arg[2]))).forEach(e -> 
                            {
                                m.send(cs, e.getKey());
                                ((Map) e.getValue()).forEach((k, v) -> m.sendListElement(cs, k + " | " + v));
                            });                   
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.");
                        }
                        return true;
                    }
                    break;
                }*/
                case "see":
                {
                    Collection<Script> scripts = KajetansMod.scripts.getSnuviParser().getScripts();
                    if(scripts.isEmpty())
                    {
                        m.send(cs, "Momentan sind keine Scripts aktiv.");
                        return true;
                    }
                    m.send(cs, "Folgende Scripts sind aktiv:");
                    scripts.forEach(sc ->
                    {
                        m.sendHelpListElement(cs, sc.getSimpleName(), "(" + sc.getId() + ")");
                        KajetansMod.scripts.getPlayerList(sc.getId()).forEach(uuid -> 
                        {
                            EntityPlayerMP p = KajetansMod.server.getPlayerList().getPlayerByUUID(uuid);
                            m.sendListElement(cs, p == null ? "null" : p.getName());
                        });
                    });
                    return true;
                }
                case "term":
                {
                    if(arg.length >= 2)
                    {
                        try
                        {
                            if(arg[1].equals("all"))
                            {
                                KajetansMod.scripts.clearPlayerRegistry();
                                KajetansMod.scripts.getSnuviParser().termAllUnsafe();
                                m.send(cs, "Alle aktiven Scripts wurden beendet.");
                                return true;
                            }
                            Script qd = KajetansMod.scripts.getSnuviParser().getScript(Integer.parseInt(arg[1]));
                            if(!KajetansMod.scripts.getSnuviParser().termUnsafe(qd))
                            {
                                throw new NumberFormatException();
                            }
                            m.send(cs, "Das Script '" + qd.getName() + "' wurde beendet.");
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.");
                        } 
                        catch(Exception ex)
                        {
                            m.send(cs, "Beim unsicheren Beenden eines Scripts trat ein Fehler auf.");
                            ex.printStackTrace();
                        } 
                        return true;
                    }
                    break;
                }
            }
        }
        
        m.send(cs, "/script ...");
        m.sendHelpListElement(cs, "start <scripts...>", "Startet ein Script");
        m.sendHelpListElement(cs, "startp <player> <scripts...>", "Startet ein Script");
        m.sendHelpListElement(cs, "variable <id> <name>", "Zeigt den Wert einer Variable");       
        //m.sendHelpListElement(cs, "printvars <id> [starts]", "Zeigt alle Variablen");
        //m.sendHelpListElement(cs, "printlists <id> [starts]", "Zeigt alle Listen");
        //m.sendHelpListElement(cs, "printmaps <id> [starts]", "Zeigt alle Maps");
        m.sendHelpListElement(cs, "next <id>", "Springt in die nächste Codezeile");
        //m.sendHelpListElement(cs, "code <id> <code", "Führt den angegebenen Code aus");
        m.sendHelpListElement(cs, "see", "Gibt alle aktiven Scripts aus");
        m.sendHelpListElement(cs, "term <id/all>", "Entfernt Scripts aus dem RAM");
        return true;
    }
}

