package me.km.snuviscript;

import com.mojang.authlib.GameProfile;
import java.io.File;
import me.km.KajetansMod;
import me.km.utils.NBTUtils;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.UUID;
import java.util.function.Consumer;
import me.hammerle.snuviscript.code.Script;
import me.hammerle.snuviscript.code.SnuviUtils;
import me.hammerle.snuviscript.code.SnuviParser;
import me.km.utils.Location;
import me.km.utils.TitleUtils;
import me.km.utils.Utils;
import me.km.chatchannel.ChatChannel;
import me.km.world.ModDimensions;
import me.km.effects.EffectUtils;
import me.km.inventory.InventoryUtils;
import me.km.utils.ItemStackUtils;
import me.km.utils.ReflectionUtils;
import me.km.utils.SpecialBlockUtils;
import net.minecraft.block.Block;
import net.minecraft.block.BlockDoor;
import net.minecraft.block.state.IBlockState;
import net.minecraft.command.ICommandSender;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.item.EntityItemFrame;
import net.minecraft.entity.monster.EntityCreeper;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.entity.projectile.EntityPotion;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.network.ThreadQuickExitException;
import net.minecraft.network.play.client.CPacketChatMessage;
import net.minecraft.network.play.client.CPacketClientStatus;
import net.minecraft.network.play.server.SPacketSpawnPosition;
import net.minecraft.potion.Potion;
import net.minecraft.potion.PotionUtils;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.tileentity.TileEntityChest;
import net.minecraft.tileentity.TileEntitySign;
import net.minecraft.util.DamageSource;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.SoundEvent;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;
import net.minecraft.world.WorldServer;
import me.km.events.CustomEventCaller;
import me.km.events.PlayerMoveData;
import me.km.exception.IllegalStringException;
import me.km.exception.PlayerNotFoundException;
import me.km.inventory.CustomContainer;
import me.km.items.tools.*;
import me.km.items.weapons.*;
import me.km.networking.ModPacketHandler;
import me.km.playerbank.PlayerBank;
import me.km.playerbank.PlayerManager;
import me.km.scoreboard.ScoreboardUtils;
import me.km.utils.TableUtils;
import net.minecraft.block.BlockCrops;
import net.minecraft.entity.EntityList;
import net.minecraft.entity.effect.EntityLightningBolt;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemAxe;
import net.minecraft.nbt.JsonToNBT;
import net.minecraft.nbt.NBTException;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTUtil;
import net.minecraft.potion.PotionEffect;
import net.minecraft.server.management.PlayerList;
import net.minecraft.server.management.UserListBansEntry;
import net.minecraft.tileentity.TileEntityMobSpawner;
import net.minecraft.tileentity.TileEntitySkull;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.world.EnumDifficulty;
import net.minecraft.world.GameType;
import net.minecraft.world.chunk.storage.AnvilChunkLoader;
import net.minecraft.world.storage.WorldInfo;

public class MinecraftFunctions
{
    public static int inventoryIds = 0;

    @SuppressWarnings("")
    public static void registerFunctions(SnuviParser parser)
    {
        // ---------------------------------------------------------------------
        // Command-library  
        // ---------------------------------------------------------------------
        parser.registerFunction("command.add", (sc, in) -> 
        {
            KajetansMod.scripts.registerScriptCommand(in[0].getString(sc));
            return Void.TYPE;
        }); 
        parser.registerFunction("command.remove", (sc, in) -> 
        {
            KajetansMod.scripts.unregisterScriptCommand(in[0].getString(sc));
            return Void.TYPE;
        }); 
        parser.registerFunction("command.exists", (sc, in) -> KajetansMod.scripts.isRegisteredScriptCommand(in[0].getString(sc)));
        parser.registerFunction("command.clear", (sc, in) -> 
        {
            KajetansMod.scripts.clearScriptCommands();
            return Void.TYPE;
        }); 
        
        // ---------------------------------------------------------------------
        // Permission-library  
        // ---------------------------------------------------------------------
        parser.registerFunction("perm.clear", (sc, in) -> 
        {
            KajetansMod.perms.clear();
            return Void.TYPE;
        }); 
        parser.registerFunction("perm.registergroup", (sc, in) -> 
        {
            KajetansMod.perms.registerGroupPermission(in[0].getInt(sc), in[1].getString(sc));
            return Void.TYPE;
        }); 
        parser.registerFunction("perm.registerplayer", (sc, in) -> 
        {
            KajetansMod.perms.registerPlayerGroup(getUUID(in[0].get(sc)), in[1].getInt(sc));
            return Void.TYPE;
        }); 
        parser.registerFunction("perm.unregisterplayer", (sc, in) -> KajetansMod.perms.unregisterPlayer(getUUID(in[0].get(sc)), in[1].getInt(sc))); 
        parser.registerFunction("perm.has", (sc, in) -> KajetansMod.perms.hasPermission((ICommandSender) in[0].get(sc), in[1].getString(sc))); 
        
        // ---------------------------------------------------------------------
        // Title-library  
        // ---------------------------------------------------------------------
        parser.registerFunction("title.settime", (sc, in) -> 
        {
            TitleUtils.setTitleTime((EntityPlayerMP) in[0].get(sc), in[1].getInt(sc), in[2].getInt(sc), in[3].getInt(sc));
            return Void.TYPE;
        });
        parser.registerFunction("title.clear", (sc, in) -> 
        { 
            TitleUtils.clearTitle((EntityPlayerMP) in[0].get(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("title.reset", (sc, in) -> 
        { 
            TitleUtils.resetTitle((EntityPlayerMP) in[0].get(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("title.send", (sc, in) -> 
        { 
            TitleUtils.setTitle((EntityPlayerMP) in[0].get(sc), SnuviUtils.connect(sc, in, 1)); 
            return Void.TYPE; 
        });
        parser.registerFunction("title.setsub", (sc, in) -> 
        { 
            TitleUtils.setSubTitle((EntityPlayerMP) in[0].get(sc), SnuviUtils.connect(sc, in, 1)); 
            return Void.TYPE; 
        });
        
        // ---------------------------------------------------------------------
        // Villager-library  
        // ---------------------------------------------------------------------
        parser.registerFunction("villager.showtrades", (sc, in) -> 
        { 
            ((EntityPlayer) in[0].get(sc)).displayVillagerTradeGui(((EntityVillager) in[1].get(sc))); 
            return Void.TYPE; 
        });
       
        // ---------------------------------------------------------------------    
        // Player-library
        // ---------------------------------------------------------------------  
        parser.registerFunction("player.getitemamount", (sc, in) -> (double) InventoryUtils.searchInventoryFor(((EntityPlayer) in[0].get(sc)).inventory, (ItemStack) in[2].get(sc), in[1].getBoolean(sc)));                
        parser.registerFunction("player.removeitem", (sc, in) -> 
        { 
            ItemStack stack = ((ItemStack) in[1].get(sc)).copy();
            stack.setCount(InventoryUtils.removeFromInventory(((EntityPlayer) in[0].get(sc)).inventory, stack));
            return stack;
        });                 
        parser.registerFunction("player.giveitem", (sc, in) -> 
        {       
            ItemStack stack = ((ItemStack) in[1].get(sc)).copy();
            stack.setCount(InventoryUtils.addToInventory(((EntityPlayer) in[0].get(sc)).inventory, stack));
            return stack;
        });
        parser.registerFunction("player.shootprojectile", (sc, in) -> EffectUtils.launchProjectile((EntityPlayer) in[0].get(sc), getClass(in[1].getString(sc)), in[2].getDouble(sc), in[3].get(sc)));
        parser.registerFunction("player.respawn", (sc, in) -> 
        {
            final EntityPlayerMP p = ((EntityPlayerMP) in[0].get(sc));
            KajetansMod.scheduler.scheduleTask(() ->
            {
                try
                {
                    p.connection.processClientStatus(new CPacketClientStatus(CPacketClientStatus.State.PERFORM_RESPAWN));
                }
                catch(ThreadQuickExitException ex)
                {
                    // Minecraft needs this for canceling and queueing into main thread
                }
            });
            return Void.TYPE; 
        });
        parser.registerFunction("player.clearinventory", (sc, in) -> 
        { 
            ((EntityPlayer) in[0].get(sc)).inventory.clear();
            return Void.TYPE; 
        });  
        parser.registerFunction("player.inventorytolist", (sc, in) -> 
        { 
            in[0].set(sc, ((EntityPlayer) in[1].get(sc)).inventory.mainInventory); 
            return Void.TYPE; 
        });    
        parser.registerFunction("player.getnearest", (sc, in) -> 
        {
            Location l = (Location) in[0].get(sc);
            return l.getWorld().getClosestPlayer(l.getX(), l.getY(), l.getZ(), -1, p -> true);
        }); 
        parser.registerFunction("player.say", (sc, in) -> 
        {
            try
            {
                ((EntityPlayerMP) in[0].get(sc)).connection.processChatMessage(new CPacketChatMessage(SnuviUtils.connect(sc, in, 1)));
            }
            catch(ThreadQuickExitException ex)
            {
                // Minecraft needs this for canceling and queueing into main thread
            }
            return Void.TYPE; 
        });
        parser.registerFunction("player.speak", (sc, in) -> 
        { 
            sendMessageToGroup(in[0].get(sc), sc, NBTUtils.concat(sc, 2, "§7[§r" + in[1].getString(sc) + "§7]§r ", in)); 
            return Void.TYPE; 
        });
        parser.registerFunction("player.setcompass", (sc, in) -> 
        { 
            ((EntityPlayerMP) in[0].get(sc)).connection.sendPacket(new SPacketSpawnPosition(((Location) in[1].get(sc)).getBlockPos())); 
            return Void.TYPE; 
        }); 
        parser.registerFunction("player.gethunger", (sc, in) -> (double) ((EntityPlayer) in[0].get(sc)).getFoodStats().getFoodLevel());
        parser.registerFunction("player.sethunger", (sc, in) -> 
        { 
            ((EntityPlayer) in[0].get(sc)).getFoodStats().setFoodLevel(in[1].getInt(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("player.getsaturation", (sc, in) -> (double) ReflectionUtils.getSaturation(((EntityPlayer) in[0].get(sc)).getFoodStats()));
        parser.registerFunction("player.setsaturation", (sc, in) -> 
        { 
            ReflectionUtils.setSaturation(((EntityPlayer) in[0].get(sc)).getFoodStats(), in[1].getFloat(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("player.getname", (sc, in) -> 
        { 
            Object o = in[0].get(sc);
            if(o instanceof EntityPlayer)
            {
                return ((EntityPlayer) o).getName();
            }
            return KajetansMod.server.getPlayerProfileCache().getProfileByUUID(getUUID(o.toString())).getName();
        });
        parser.registerFunction("player.getuuid", (sc, in) -> 
        { 
            Object o = in[0].get(sc);
            if(o instanceof EntityPlayer)
            {
                return ((EntityPlayer) o).getUniqueID();
            }
            return KajetansMod.playerbank.getDataBank().getUUID(o.toString());
        });
        parser.registerFunction("player.getid", (sc, in) -> KajetansMod.playerbank.getPlayerId(getUUID(in[0].get(sc))));
        parser.registerFunction("player.get", (sc, in) -> 
        { 
            return KajetansMod.server.getPlayerList().getPlayerByUUID(getUUID(in[0].get(sc)));
        });
        parser.registerFunction("player.getip", (sc, in) -> ((EntityPlayerMP) in[0].get(sc)).connection.netManager.getRemoteAddress().toString());
        parser.registerFunction("player.iscreative", (sc, in) -> ((EntityPlayer) in[0].get(sc)).isCreative());
        parser.registerFunction("player.isspectator", (sc, in) -> ((EntityPlayer) in[0].get(sc)).isSpectator());
        parser.registerFunction("player.issurvival", (sc, in) -> 
        { 
            EntityPlayer p = (EntityPlayer) in[0].get(sc);
            return !p.isCreative() && !p.isSpectator();
        });
        parser.registerFunction("player.isadventure", (sc, in) -> !((EntityPlayer) in[0].get(sc)).capabilities.allowEdit);
        parser.registerFunction("player.setfly", (sc, in) -> 
        {
            EntityPlayer p = ((EntityPlayer) in[0].get(sc));
            boolean b = in[1].getBoolean(sc);
            p.capabilities.allowFlying = b;
            p.capabilities.isFlying = b;
            p.sendPlayerAbilities();
            return Void.TYPE;
        });
        parser.registerFunction("player.hasfly", (sc, in) -> ((EntityPlayer) in[0].get(sc)).capabilities.allowFlying);
        parser.registerFunction("player.setgamemode", (sc, in) -> 
        { 
            EntityPlayer p = (EntityPlayer) in[0].get(sc);
            switch(in[1].get(sc).toString()) 
            {
                case "survival":
                case "s":
                case "0":  
                    p.setGameType(GameType.SURVIVAL);
                    break;
                case "creative":
                case "c":        
                case "1":  
                    p.setGameType(GameType.CREATIVE);
                    break;
                case "adventure":         
                case "a":         
                case "2":  
                    p.setGameType(GameType.ADVENTURE);
                    break;
                case "spectator":         
                case "w":         
                case "3":  
                    p.setGameType(GameType.SPECTATOR);
                    break;  
                default:
                    p.setGameType(GameType.CREATIVE);
                    break;
            }
            return Void.TYPE;
        });
        parser.registerFunction("player.getlastdamager", (sc, in) -> 
        { 
            DamageSource ds = ((EntityPlayer) in[0].get(sc)).getLastDamageSource();
            if(ds == null)
            {
                return null;
            }
            return ds.getImmediateSource();
        });
        parser.registerFunction("player.dropinventory", (sc, in) -> 
        { 
            ((EntityPlayer) in[0].get(sc)).inventory.dropAllItems();
            return Void.TYPE; 
        });
        parser.registerFunction("player.gettarget", (sc, in) -> 
        { 
            if(in.length > 2)
            {
                return new Location(((EntityPlayer) in[0].get(sc)).world, 
                        Utils.getTargetBlock((EntityPlayer) in[0].get(sc), in[1].getInt(sc), in[2].getBoolean(sc)));
            }
            return new Location(((EntityPlayer) in[0].get(sc)).world, Utils.getTargetBlock((EntityPlayer) in[0].get(sc), in[1].getInt(sc)));
        });
                
        parser.registerFunction("player.gettargetentity", (sc, in) -> Utils.getTargetedEntity((EntityPlayer) in[0].get(sc), in[1].getDouble(sc), getClass(in[2].getString(sc))));
        parser.registerFunction("player.hasscript", (sc, in) -> KajetansMod.scripts.isRegistered((EntityPlayer) in[0].get(sc)));
        parser.registerAlias("player.hasscript", "player.hasquest");
        parser.registerFunction("player.action", (sc, in) -> 
        {     
            TextComponentString text = new TextComponentString(SnuviUtils.connect(sc, in, 1));
            doForGroup(in[0].get(sc), sc, p -> ((EntityPlayerMP) p).sendStatusMessage(text, true));
            return Void.TYPE; 
        }); 
        parser.registerFunction("player.disconnect", (sc, in) -> 
        {
            ((EntityPlayerMP) in[0].get(sc)).connection.disconnect(new TextComponentString(in[1].getString(sc)));
            return Void.TYPE; 
        }); 
        parser.registerFunction("player.kick", (sc, in) -> KajetansMod.scripts.unregisterPlayer(sc, (EntityPlayer) in[0].get(sc)));  
        parser.registerFunction("player.playsound", (sc, in) -> 
        { 
            EffectUtils.playSound((EntityPlayerMP) in[0].get(sc), SoundEvent.REGISTRY.getObject(new ResourceLocation(in[1].getString(sc))), SoundCategory.MASTER);
            return Void.TYPE; 
        });
        parser.registerFunction("player.getspawn", (sc, in) -> 
        {   
            WorldServer ws = (WorldServer) in[1].get(sc);
            return new Location(ws, ((EntityPlayer) in[0].get(sc)).getBedLocation(ws.provider.getDimension()));
        });
        parser.registerAlias("player.getspawn", "player.getbedspawn");
        parser.registerFunction("player.setspawn", (sc, in) -> 
        {     
            Location l = (Location) in[1].get(sc);
            ((EntityPlayerMP) in[0].get(sc)).setSpawnChunk(l.getBlockPos(), true, l.getWorld().provider.getDimension());
            return Void.TYPE; 
        });
        parser.registerAlias("player.setspawn", "player.setbedspawn");
        parser.registerFunction("player.damageitem", (sc, in) -> 
        {   
            ((EntityPlayer) in[0].get(sc)).getHeldItemMainhand().damageItem(in[1].getInt(sc), (EntityPlayer) in[0].get(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("player.openenderchest", (sc, in) -> 
        {   
            ((EntityPlayer) in[0].get(sc)).displayGUIChest(((EntityPlayer) in[1].get(sc)).getInventoryEnderChest()); 
            return Void.TYPE; 
        });
        parser.registerFunction("player.getlevel", (sc, in) -> (double) ((EntityPlayer) in[0].get(sc)).experienceLevel);
        parser.registerFunction("player.getexp", (sc, in) -> (double) ((EntityPlayer) in[0].get(sc)).experience);
        parser.registerFunction("player.addlevel", (sc, in) -> 
        {
            EntityPlayer p = (EntityPlayer) in[0].get(sc);
            p.addExperienceLevel(in[1].getInt(sc));
            return Void.TYPE; 
        });
        parser.registerFunction("player.setexp", (sc, in) -> 
        {
            EntityPlayer p = (EntityPlayer) in[0].get(sc);
            float f = in[1].getFloat(sc);
            if(f < 0.0f)
            {
                f = 0.0f;
            }
            else if(f > 1.0f)
            {
                f = 1.0f;
            }
            p.addExperience((int) (f * p.xpBarCap()));
            return Void.TYPE; 
        });
        parser.registerFunction("player.getfoodlevel", (sc, in) -> (double) ((EntityPlayer) in[0].get(sc)).getFoodStats().getFoodLevel());
        parser.registerFunction("player.getsaturationlevel", (sc, in) -> (double) ((EntityPlayer) in[0].get(sc)).getFoodStats().getSaturationLevel());
        parser.registerFunction("player.setfoodlevel", (sc, in) -> 
        {
            EntityPlayer p = (EntityPlayer) in[0].get(sc);
            p.getFoodStats().setFoodLevel(in[1].getInt(sc));
            return Void.TYPE; 
        });
        parser.registerFunction("player.setsaturationlevel", (sc, in) -> 
        {
            EntityPlayer p = (EntityPlayer) in[0].get(sc);
            p.getFoodStats().setFoodSaturationLevel(in[1].getFloat(sc));
            return Void.TYPE; 
        });
        parser.registerFunction("player.gethead", (sc, in) -> 
        {
            ItemStack stack = new ItemStack(Items.SKULL, 1, 3);
            NBTTagCompound com = stack.getTagCompound();
            if(com == null)
            {
                return stack;
            }
            GameProfile gp = KajetansMod.server.getPlayerProfileCache().getProfileByUUID(getUUID(in[0].get(sc)));
            gp = TileEntitySkull.updateGameprofile(gp);
            com.setTag("SkullOwner", NBTUtil.writeGameProfile(new NBTTagCompound(), gp));
            return stack;
        });
        parser.registerFunction("player.setspeed", (sc, in) -> 
        {
            EntityPlayer p = (EntityPlayer) in[0].get(sc);
            float f = in[1].getFloat(sc);
            ReflectionUtils.setFlySpeed(p.capabilities, f);
            ReflectionUtils.setWalkSpeed(p.capabilities, f * 2);
            p.sendPlayerAbilities();
            return true;
        });
        parser.registerFunction("player.near", (sc, in) -> 
        {     
            EntityPlayer p = (EntityPlayer) in[1].get(sc);
            in[0].set(sc, Utils.getPlayers(p, in[2].getDouble(sc))); 
            return Void.TYPE;
        });
        parser.registerFunction("player.getinvslot", (sc, in) -> 
        {     
            return ((EntityPlayer) in[0].get(sc)).inventory.mainInventory.get(in[1].getInt(sc));
        });
        parser.registerFunction("player.setinvslot", (sc, in) -> 
        {     
            ((EntityPlayer) in[0].get(sc)).inventory.mainInventory.set(in[1].getInt(sc), ((ItemStack) in[2].get(sc)).copy()); 
            return Void.TYPE;
        });
        parser.registerFunction("player.getenderslot", (sc, in) -> 
        {     
            return ((EntityPlayer) in[0].get(sc)).getInventoryEnderChest().getStackInSlot(in[1].getInt(sc));
        });
        parser.registerFunction("player.setenderslot", (sc, in) -> 
        {     
            ((EntityPlayer) in[0].get(sc)).getInventoryEnderChest().setInventorySlotContents(in[1].getInt(sc), ((ItemStack) in[2].get(sc)).copy()); 
            return Void.TYPE;
        });

        // ---------------------------------------------------------------------    
        // Players-library
        // --------------------------------------------------------------------- 
        parser.registerFunction("players.getamount", (sc, in) -> (double) KajetansMod.server.getCurrentPlayerCount());
        parser.registerFunction("players.tolist", (sc, in) -> 
        {     
            in[0].set(sc, new ArrayList(KajetansMod.server.getPlayerList().getPlayers())); 
            return Void.TYPE; 
        });    
        parser.registerFunction("players.toworldlist", (sc, in) -> 
        {     
            in[0].set(sc, new ArrayList(((World) in[1].get(sc)).playerEntities)); 
            return Void.TYPE; 
        });
        parser.registerFunction("players.near", (sc, in) -> 
        {     
            Location l = (Location) in[1].get(sc);
            in[0].set(sc, Utils.getPlayers(l.getWorld(), l.getX(), l.getY(), l.getZ(), in[2].getDouble(sc))); 
            return Void.TYPE;
        });
        
        // ---------------------------------------------------------------------    
        // Custom-library
        // ---------------------------------------------------------------------
        /*parser.registerFunction("custom.registershapelessrecipe", (sc, in) -> 
        { 
            ItemStack[] stacks = new ItemStack[in.length - 1];
            for(int i = 0; i < stacks.length; i++)
            {
                stacks[i] = (ItemStack) in[i + 1].get(sc);
            }
            RecipeUtils.registerShapelessRecipe((ItemStack) in[0].get(sc), stacks); 
            return Void.TYPE; 
        });
        parser.registerFunction("custom.registershapedrecipe", (sc, in) -> 
        { 
            int counter = 0;
            while(in[counter + 1].get(sc).getClass() == String.class)
            {
                counter++;
            }
            String[] s = new String[counter];
            for(int i = 0; i < s.length; i++)
            {
                s[i] = in[i + 1].toString();
            }

            ItemStack[] stacks = new ItemStack[in.length - 1 - s.length];
            for(int i = 0; i < stacks.length; i++)
            {
                stacks[i] = (ItemStack) in[i + 1 + counter].get(sc);
            }
            RecipeUtils.registerShapedRecipe((ItemStack) in[0].get(sc), s, stacks); 
            return Void.TYPE; 
        });
        parser.registerFunction("custom.registerfurnacerecipe", (sc, in) -> 
        {
            RecipeUtils.registerFurnaceRecipe((ItemStack) in[0].get(sc), (ItemStack) in[1].get(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("custom.clearrecipes", (sc, in) -> 
        {
            RecipeUtils.clearRecipes(); 
            return Void.TYPE; 
        });*/
        
        
        // ---------------------------------------------------------------------    
        // World-library
        // ---------------------------------------------------------------------
        
        parser.registerAlias("players.toworldlist", "world.getplayers");
        parser.registerFunction("world.get", (sc, in) -> 
        {     
            return ModDimensions.getWorldFromName(in[0].getString(sc));
        });
        parser.registerFunction("world.load", (sc, in) -> 
        {                    
            String name = in[0].getString(sc);
            if(!new File("./" + name).isDirectory())
            {
                return false;
            }
            return ModDimensions.loadWorld(name, ModDimensions.CUSTOM_WORLD);
        });    
        parser.registerFunction("world.unload", (sc, in) -> 
        {                    
            return ModDimensions.unloadWorld(in[0].getString(sc));
        });  
        parser.registerFunction("world.getname", (sc, in) -> 
        {     
            return ModDimensions.getWorldName((World) in[0].get(sc));
        });
        parser.registerFunction("world.setdiffi", (sc, in) -> 
        {                    
            EnumDifficulty diffi = EnumDifficulty.valueOf(in[1].getString(sc).toUpperCase());
            ((World) in[0].get(sc)).getWorldInfo().setDifficulty(diffi);                                     
            return Void.TYPE;
        });  
        parser.registerFunction("world.setgamerule", (sc, in) -> 
        {                    
            ((World) in[0].get(sc)).getGameRules().setOrCreateGameRule(in[1].getString(sc), in[2].getString(sc));
            return Void.TYPE;
        });  
        parser.registerFunction("world.getgamerule", (sc, in) -> 
        {                    
            return ((World) in[0].get(sc)).getGameRules().getString(in[1].getString(sc));
        });  
        parser.registerFunction("world.setspawn", (sc, in) -> 
        {    
            Location l = ((Location) in[0].get(sc));
            l.getWorld().setSpawnPoint(l.getBlockPos());
            return Void.TYPE;
        });
        parser.registerFunction("world.getspawn", (sc, in) -> 
        {    
            World w = (World) in[0].get(sc);
            return new Location(w, w.getSpawnPoint());
        });
        parser.registerFunction("world.getall", (sc, in) -> 
        {    
            ArrayList<World> worlds = new ArrayList<>();
            for(World w : KajetansMod.server.worlds)
            {
                worlds.add(w);
            }
            return worlds;
        });
        parser.registerFunction("world.settime", (sc, in) -> 
        {    
            ((World) in[0].get(sc)).setWorldTime(in[0].getLong(sc));
            return Void.TYPE;
        });
        parser.registerFunction("world.clearweather", (sc, in) -> 
        {    
            WorldInfo wi = ((World) in[0].get(sc)).getWorldInfo();
            wi.setCleanWeatherTime(in[1].getInt(sc));
            wi.setRainTime(0);
            wi.setThunderTime(0);
            wi.setRaining(false);
            wi.setThundering(false);
            return Void.TYPE;
        });
        parser.registerFunction("world.setrain", (sc, in) -> 
        {    
            WorldInfo wi = ((World) in[0].get(sc)).getWorldInfo();
            wi.setCleanWeatherTime(0);
            int i = in[1].getInt(sc);
            wi.setRainTime(i);
            wi.setThunderTime(i);
            wi.setRaining(true);
            wi.setThundering(false);
            return Void.TYPE;
        });
        parser.registerFunction("world.setthunder", (sc, in) -> 
        {    
            WorldInfo wi = ((World) in[0].get(sc)).getWorldInfo();
            wi.setCleanWeatherTime(0);
            int i = in[1].getInt(sc);
            wi.setRainTime(i);
            wi.setThunderTime(i);
            wi.setRaining(true);
            wi.setThundering(true);
            return Void.TYPE;
        });
        
        // ---------------------------------------------------------------------    
        // Item-library   
        // ---------------------------------------------------------------------   
        parser.registerFunction("item.drop", (sc, in) -> 
        {       
            Location l = (Location) in[0].get(sc);
            World w = l.getWorld();
            BlockPos pos = l.getBlockPos();
            ItemStack stack = ((ItemStack) in[1].get(sc)).copy();
            int amount = stack.getCount();
            while(amount > stack.getMaxStackSize())
            {            
                stack.setCount(stack.getMaxStackSize());
                amount -= stack.getMaxStackSize();
                ItemStackUtils.drop(w, pos, stack.copy());
            }
            if(amount > 0)
            {
                stack.setCount(amount);
                ItemStackUtils.drop(w, pos, stack);
            }
            return Void.TYPE; 
        });                  
        parser.registerFunction("item.gettooltype", (sc, in) -> 
        {
            ItemStack stack = (ItemStack) in[0].get(sc);
            if(stack == null)
            {
                return -1.0;
            }
            Item item = stack.getItem();
            if(item instanceof ItemAxe) return 0.0;
            else if(item instanceof ItemHammer) return 1.0;
            else if(item instanceof ItemHoe) return 2.0;
            else if(item instanceof ItemPickaxe) return 3.0;
            else if(item instanceof ItemSpade) return 4.0;
            else if(item instanceof ItemBattleAxe) return 5.0;
            else if(item instanceof ItemDagger) return 6.0;
            else if(item instanceof ItemSling) return 7.0;
            else if(item instanceof ItemScepter) return 8.0;
            else if(item instanceof ItemStick) return 9.0;
            else if(item instanceof ItemSword) return 10.0;
            return -1.0;
        });
        parser.registerFunction("item.get", (sc, in) -> ((ItemStack) in[0].get(sc)).getItem());
        parser.registerFunction("item.gettype", (sc, in) -> ((ItemStack) in[0].get(sc)).getItem().getRegistryName().toString());
        parser.registerFunction("item.getdata", (sc, in) -> (double) ((ItemStack) in[0].get(sc)).getMetadata());           
        parser.registerFunction("item.setdata", (sc, in) -> 
        {    
            ((ItemStack) in[0].get(sc)).setItemDamage(in[1].getInt(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("item.getamount", (sc, in) -> (double) ((ItemStack) in[0].get(sc)).getCount()); 
        parser.registerFunction("item.setamount", (sc, in) -> 
        {   
            ((ItemStack) in[0].get(sc)).setCount(in[1].getInt(sc));
            return Void.TYPE; 
        });   
        parser.registerFunction("item.getname", (sc, in) -> ((ItemStack) in[0].get(sc)).getDisplayName());
        parser.registerFunction("item.setname", (sc, in) -> 
        {   
            ((ItemStack) in[0].get(sc)).setStackDisplayName(SnuviUtils.connect(sc, in, 1)); 
            return Void.TYPE; 
        });
        parser.registerFunction("item.getlore", (sc, in) -> 
        {    
            in[0].set(sc, ItemStackUtils.getLore((ItemStack) in[1].get(sc))); 
            return Void.TYPE; 
        });
        parser.registerFunction("item.setlore", (sc, in) -> 
        {   
            ItemStackUtils.setLore((ItemStack) in[0].get(sc), (List<String>) in[1].get(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("item.addlore", (sc, in) -> 
        {   
            ItemStackUtils.addLore((ItemStack) in[0].get(sc), SnuviUtils.connect(sc, in, 2), in[1].getInt(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("item.addenchant", (sc, in) -> 
        {
            ItemStack stack = (ItemStack) in[0].get(sc);
            Enchantment ench = Enchantment.getEnchantmentByLocation(in[1].getString(sc));
            int i = in[2].getInt(sc);
            stack.addEnchantment(ench, i);
            return true;
        });
        parser.registerFunction("item.getenchantlevel", (sc, in) -> (double) EnchantmentHelper.getEnchantmentLevel(Enchantment.getEnchantmentByLocation(in[1].getString(sc)), (ItemStack) in[0].get(sc)));
        parser.registerFunction("item.setcooldown", (sc, in) -> 
        {   
            ((EntityPlayer) in[0].get(sc)).getCooldownTracker().setCooldown(((ItemStack) in[1].get(sc)).getItem(), in[2].getInt(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("item.addpotion", (sc, in) -> 
        { 
            ItemStack stack = (ItemStack) in[0].get(sc);
            ArrayList<PotionEffect> list = new ArrayList<>();
            list.add(new PotionEffect(Potion.getPotionFromResourceLocation(in[1].getString(sc)), in[2].getInt(sc), in[3].getInt(sc)));
            PotionUtils.appendEffects(stack, list);
            return Void.TYPE;
        });

        // ---------------------------------------------------------------------    
        // Location-library
        // ---------------------------------------------------------------------  
        parser.registerFunction("loc.new", (sc, in) -> 
        { 
            if(in.length >= 6)
            {
                return new Location((World) in[0].get(sc), 
                        in[1].getDouble(sc), in[2].getDouble(sc), in[3].getDouble(sc), 
                        in[4].getFloat(sc), in[5].getFloat(sc));
            }
            return new Location((World) in[0].get(sc), in[1].getDouble(sc), in[2].getDouble(sc), in[3].getDouble(sc), 0, 0);
        });   
        parser.registerFunction("loc.getx", (sc, in) -> ((Location) in[0].get(sc)).getX());  
        parser.registerFunction("loc.gety", (sc, in) -> ((Location) in[0].get(sc)).getY());  
        parser.registerFunction("loc.getz", (sc, in) -> ((Location) in[0].get(sc)).getZ());  
        parser.registerFunction("loc.setx", (sc, in) -> 
        { 
            ((Location) in[0].get(sc)).setX(in[1].getDouble(sc)); 
            return Void.TYPE; 
        });  
        parser.registerFunction("loc.sety", (sc, in) -> 
        { 
            ((Location) in[0].get(sc)).setY(in[1].getDouble(sc)); 
            return Void.TYPE; 
        });  
        parser.registerFunction("loc.setz", (sc, in) -> 
        { 
            ((Location) in[0].get(sc)).setZ(in[1].getDouble(sc)); 
            return Void.TYPE; 
        });  
        parser.registerFunction("loc.addx", (sc, in) -> 
        { 
            ((Location) in[0].get(sc)).addX(in[1].getDouble(sc)); 
            return Void.TYPE; 
        });  
        parser.registerFunction("loc.addy", (sc, in) -> 
        { 
            ((Location) in[0].get(sc)).addY(in[1].getDouble(sc)); 
            return Void.TYPE; 
        });  
        parser.registerFunction("loc.addz", (sc, in) -> 
        { 
            ((Location) in[0].get(sc)).addZ(in[1].getDouble(sc)); 
            return Void.TYPE; 
        });  
        parser.registerFunction("loc.setyaw", (sc, in) -> 
        { 
            ((Location) in[0].get(sc)).setYaw(in[1].getFloat(sc)); 
            return Void.TYPE; 
        });  
        parser.registerFunction("loc.getyaw", (sc, in) -> (double) ((Location) in[0].get(sc)).getYaw());  
        parser.registerFunction("loc.setpitch", (sc, in) -> 
        { 
            ((Location) in[0].get(sc)).setPitch(in[1].getFloat(sc)); 
            return Void.TYPE;
        });  
        parser.registerFunction("loc.getpitch", (sc, in) -> (double) ((Location) in[0].get(sc)).getPitch());
        parser.registerFunction("loc.getworld", (sc, in) -> ((Location) in[0].get(sc)).getWorld());  
        parser.registerFunction("loc.distance", (sc, in) -> ((Location) in[0].get(sc)).getPos().distanceTo(((Location) in[1].get(sc)).getPos()));  
        parser.registerFunction("loc.mod", (sc, in) -> ((Location) in[0].get(sc)).copyAdd(in[1].getDouble(sc), in[2].getDouble(sc), in[3].getDouble(sc)));
        parser.registerFunction("loc.getcoord", (sc, in) -> 
        {
            Location l = (Location) in[0].get(sc);
            switch(in[1].getString(sc))
            {
                case "x":
                    return l.getX();
                case "y":
                    return l.getY();
                case "z":
                    return l.getZ();
                case "bx":
                    return (double) MathHelper.floor(l.getX());
                case "by":
                    return (double) MathHelper.floor(l.getY());
                case "bz":
                    return (double) MathHelper.floor(l.getZ());
                case "w":
                    return ModDimensions.getWorldName(l.getWorld());
                default:
                    return null;
            }
        });
        parser.registerFunction("loc.gettime", (sc, in) -> (double) ((Location) in[0].get(sc)).getWorld().getWorldTime());
        parser.registerFunction("loc.hasstorm", (sc, in) -> ((Location) in[0].get(sc)).getWorld().isRaining());
        parser.registerFunction("loc.isbetween", (sc, in) -> 
        { 
            Location l1 = (Location) in[0].get(sc);
            Location l2 = (Location) in[1].get(sc);
            Location l3 = (Location) in[2].get(sc);
            return l1.getX() >= Math.min(l2.getX(), l3.getX()) && l1.getX() <= Math.max(l2.getX(), l3.getX()) &&
                    l1.getY() >= Math.min(l2.getY(), l3.getY()) && l1.getY() <= Math.max(l2.getY(), l3.getY()) &&
                    l1.getZ() >= Math.min(l2.getZ(), l3.getZ()) && l1.getZ() <= Math.max(l2.getZ(), l3.getZ());
        });

        // ---------------------------------------------------------------------    
        // Block-library
        // ---------------------------------------------------------------------    
        parser.registerFunction("block.gettype", (sc, in) -> 
        {
            Location l = (Location) in[0].get(sc);
            return l.getWorld().getBlockState(l.getBlockPos()).getBlock().getRegistryName().toString();
        });
        parser.registerFunction("block.get", (sc, in) -> 
        {
            Location l = (Location) in[0].get(sc);
            return l.getWorld().getBlockState(l.getBlockPos()).getBlock();
        });
        parser.registerFunction("block.getdata", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            IBlockState state = l.getWorld().getBlockState(l.getBlockPos());
            return (double) state.getBlock().getMetaFromState(state);
        });
        parser.registerFunction("block.clone", (sc, in) -> 
        { 
            Location l0 = (Location) in[0].get(sc);
            Location l1 = (Location) in[1].get(sc);
            NBTUtils.cloneBlock(l0.getWorld(), l0.getBlockPos(), l1.getWorld(), l1.getBlockPos());
            return Void.TYPE; 
        });
        parser.registerFunction("block.set", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            ItemStack stack = (ItemStack) in[1].get(sc);
            l.getWorld().setBlockState(l.getBlockPos(), Block.getBlockFromItem(stack.getItem()).getStateFromMeta(stack.getMetadata()));
            return Void.TYPE; 
        });
        parser.registerFunction("block.set2", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            if(in.length >= 4)
            {
                NBTUtils.setBlockWithData(l.getWorld(), l.getBlockPos(), in[2].getInt(sc), Block.getBlockFromName(in[1].getString(sc)), SnuviUtils.connect(sc, in, 3));
            }
            else
            {
                NBTUtils.setBlockWithData(l.getWorld(), l.getBlockPos(), in[2].getInt(sc), Block.getBlockFromName(in[1].getString(sc)), null);
            }
            return Void.TYPE; 
        });
        parser.registerFunction("block.setsign", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            TileEntitySign sign = (TileEntitySign) l.getWorld().getTileEntity(l.getBlockPos());
            SpecialBlockUtils.setSignLine(sign, in[1].getInt(sc), SnuviUtils.connect(sc, in, 2));
            return Void.TYPE;
        });
        parser.registerFunction("block.getsign", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            TileEntitySign sign = (TileEntitySign) l.getWorld().getTileEntity(l.getBlockPos());
            return sign.signText[in[1].getInt(sc)].getUnformattedText();
        });
        parser.registerFunction("block.setdoorstatus", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            BlockPos pos = l.getBlockPos();
            ((BlockDoor) l.getWorld().getBlockState(pos).getBlock()).toggleDoor(l.getWorld(), pos, in[1].getBoolean(sc));
            return Void.TYPE; 
        });
        parser.registerFunction("block.getdoorstatus", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            return BlockDoor.isOpen(l.getWorld(), l.getBlockPos());
        });
        parser.registerFunction("block.isdoor", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            return l.getWorld().getBlockState(l.getBlockPos()).getBlock() instanceof BlockDoor;
        });
        parser.registerFunction("block.issolid", (sc, in) -> 
        { 
            IBlockState state = getBlockState((Location) in[0].get(sc));
            return state.isFullBlock() && state.isOpaqueCube(); 
        });
        parser.registerFunction("block.tostack", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            World w = l.getWorld();
            BlockPos pos = l.getBlockPos();
            IBlockState state = w.getBlockState(pos);
            return state.getBlock().getItem(w, pos, state);
        });
        parser.registerFunction("block.getitemamount", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            TileEntity te = l.getWorld().getTileEntity(l.getBlockPos());
            if(te == null || !(te instanceof TileEntityChest))
            {
                return 0.0d;
            }        
            return (double) InventoryUtils.searchInventoryFor((TileEntityChest) te, (ItemStack) in[2].get(sc), in[1].getBoolean(sc));
        });
        parser.registerFunction("block.getsecchest", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            TileEntity te = l.getWorld().getTileEntity(l.getBlockPos());
            if(te == null || !(te instanceof TileEntityChest))
            {
                return null;
            }        
            TileEntityChest chest = (TileEntityChest) te;
            if(chest.adjacentChestXNeg != null)
            {
                return new Location(l.getWorld(), chest.adjacentChestXNeg.getPos());
            }
            if(chest.adjacentChestXPos != null)
            {
                return new Location(l.getWorld(), chest.adjacentChestXPos.getPos());
            }
            if(chest.adjacentChestZNeg != null)
            {
                return new Location(l.getWorld(), chest.adjacentChestZNeg.getPos());
            }
            if(chest.adjacentChestZPos != null)
            {
                return new Location(l.getWorld(), chest.adjacentChestZPos.getPos());
            }
            return null;
        });
        parser.registerFunction("block.additem", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            ItemStack stack = ((ItemStack) in[1].get(sc));
            TileEntity te = l.getWorld().getTileEntity(l.getBlockPos());
            if(te == null || !(te instanceof TileEntityChest))
            {
                return stack;
            }        
            stack.setCount(InventoryUtils.addToInventory((TileEntityChest) te, stack));  
            return stack;
        });
        parser.registerFunction("block.subitem", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            ItemStack stack = ((ItemStack) in[1].get(sc));
            TileEntity te = l.getWorld().getTileEntity(l.getBlockPos());
            if(te == null || !(te instanceof TileEntityChest))
            {
                return stack;
            }        
            stack.setCount(InventoryUtils.removeFromInventory((TileEntityChest) te, stack));  
            return stack;
        });  
        parser.registerFunction("block.grow", (sc, in) ->
        {
            Location l1 = (Location) in[0].get(sc);
            World w = l1.getWorld();
            BlockPos pos1 = l1.getBlockPos();
            BlockPos pos2 = ((Location) in[1].get(sc)).getBlockPos();

            int x = Math.min(pos1.getX(), pos2.getX());
            int endX = Math.max(pos1.getX(), pos2.getX());

            int y = Math.min(pos1.getY(), pos2.getY());
            int endY = Math.max(pos1.getY(), pos2.getY());

            int z = Math.min(pos1.getZ(), pos2.getZ());
            int endZ = Math.max(pos1.getZ(), pos2.getZ());

            if(endX - x > 50 || endY - y > 50 || endZ - z > 50)
            {
                throw new IllegalArgumentException("uhh, that area seems way to big for growing plants");
            }

            BlockPos relative;
            IBlockState state;
            for(; x <= endX; x++)
            {
                for(; y <= endY; y++)
                {
                    for(; z <= endZ; z++)
                    {
                        relative = new BlockPos(x, y, z);
                        state = w.getBlockState(relative);
                        if(state.getBlock() instanceof BlockCrops)
                        {
                            w.setBlockState(relative, state.withProperty(BlockCrops.AGE, 7));                
                        }                      
                    }
                }
            }
            return Void.TYPE;
        });  
        parser.registerFunction("block.setspawnertype", (sc, in) ->
        {
            Location l = (Location) in[0].get(sc);
            Class<? extends Entity> c = getClass(in[1].getString(sc));
            TileEntityMobSpawner spawner = (TileEntityMobSpawner) l.getWorld().getTileEntity(l.getBlockPos());
            spawner.getSpawnerBaseLogic().setEntityId(EntityList.getKey(c));
            return Void.TYPE;
        });  

        // ---------------------------------------------------------------------    
        // Event-library 
        // ---------------------------------------------------------------------  
        parser.registerFunction("event.addmovedata", (sc, in) -> (double) CustomEventCaller.registerMoveData(new PlayerMoveData(
                sc, (Location) in[0].get(sc), (Location) in[1].get(sc), in[2].getInt(sc), in[3].getInt(sc))));
        parser.registerFunction("event.removemovedata", (sc, in) -> 
        { 
            CustomEventCaller.removeMoveData(in[0].getInt(sc));
            return Void.TYPE; 
        });

        // ---------------------------------------------------------------------    
        // Entity - Befehle
        // ---------------------------------------------------------------------  
        parser.registerFunction("entity.getlocation", (sc, in) -> new Location((Entity) in[0].get(sc)));   
        parser.registerFunction("entity.damage", (sc, in) -> 
        { 
            // entity.damage(entity, damagefloat, DamageSource);
            if(in.length >= 3)
            {
                ((EntityLivingBase) in[0].get(sc)).attackEntityFrom((DamageSource) in[2].get(sc), in[1].getFloat(sc));
                return Void.TYPE; 
            }
            ((EntityLivingBase) in[0].get(sc)).attackEntityFrom(DamageSource.GENERIC, in[1].getFloat(sc));
            return Void.TYPE; 
        }); 
        parser.registerFunction("entity.getdamagesource", (sc, in) -> 
        { 
            Object o = in[0].get(sc);
            if(o instanceof EntityLivingBase)
            {
                EntityLivingBase ent = (EntityLivingBase) o;
                DamageSource ds;
                if(ent instanceof EntityPlayer)
                {
                    ds = DamageSource.causePlayerDamage((EntityPlayer) ent);
                }
                else
                {
                    ds = DamageSource.causeMobDamage(ent);
                }

                if(in[1].getBoolean(sc))
                {
                    ds.setDamageAllowedInCreativeMode();
                }
                if(in[2].getBoolean(sc))
                {
                    ds.setDamageBypassesArmor();
                }
                if(in[3].getBoolean(sc))
                {
                    ds.setDamageIsAbsolute();
                }
                if(in[4].getBoolean(sc))
                {
                    ds.setExplosion();
                }
                if(in[5].getBoolean(sc))
                {
                    ds.setFireDamage();
                }
                if(in[6].getBoolean(sc))
                {
                    ds.setMagicDamage();
                }
                if(in[7].getBoolean(sc))
                {
                   ds.setProjectile();
                } 
                return ds;
            }

            switch(o.toString())
            {
                case "IN_FIRE": return DamageSource.IN_FIRE;
                case "LIGHTNING_BOLT": return DamageSource.LIGHTNING_BOLT;
                case "ON_FIRE": return DamageSource.ON_FIRE;
                case "LAVA": return DamageSource.LAVA;
                case "HOT_FLOOR": return DamageSource.HOT_FLOOR;
                case "IN_WALL": return DamageSource.IN_WALL;
                case "CRAMMING": return DamageSource.CRAMMING;
                case "DROWN": return DamageSource.DROWN;
                case "STARVE": return DamageSource.STARVE;
                case "CACTUS": return DamageSource.CACTUS;
                case "FALL": return DamageSource.FALL;
                case "FLY_INTO_WALL": return DamageSource.FLY_INTO_WALL;
                case "OUT_OF_WORLD": return DamageSource.OUT_OF_WORLD;
                case "GENERIC": return DamageSource.GENERIC;
                case "MAGIC": return DamageSource.MAGIC;
                case "WITHER": return DamageSource.WITHER;
                case "ANVIL": return DamageSource.ANVIL;
                case "FALLING_BLOCK": return DamageSource.FALLING_BLOCK;
                case "DRAGON_BREATH": return DamageSource.DRAGON_BREATH;
                case "FIREWORKS": return DamageSource.FIREWORKS;
                case "THORNS": return DamageSource.causeThornsDamage((Entity) in[1].get(sc));
            }
            return DamageSource.GENERIC;
        });
        parser.registerFunction("entity.gethealth", (sc, in) -> (double) ((EntityLivingBase) in[0].get(sc)).getHealth());     
        parser.registerFunction("entity.sethealth", (sc, in) -> 
        { 
            ((EntityLivingBase) in[0].get(sc)).setHealth(in[1].getFloat(sc)); 
            return Void.TYPE; 
        });  
        parser.registerFunction("entity.setname", (sc, in) -> 
        { 
            Entity ent = (Entity) in[0].get(sc);
            ent.setCustomNameTag(in[1].getString(sc));
            if(in.length >= 3)
            {
                ent.setAlwaysRenderNameTag(in[2].getBoolean(sc));   
                return Void.TYPE; 
            }
            ent.setAlwaysRenderNameTag(true);  
            return Void.TYPE; 
        }); 
        parser.registerFunction("entity.getname", (sc, in) -> ((Entity) in[0].get(sc)).getDisplayName().getUnformattedText()); 
        parser.registerFunction("entity.throw", (sc, in) -> 
        { 
            Utils.setVelocity((Entity) in[0].get(sc), in[1].getDouble(sc), in[2].getDouble(sc), in[3].getDouble(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("entity.teleport", (sc, in) -> 
        { 
            Utils.teleportEntity((Entity) in[0].get(sc), (Location) in[1].get(sc)); 
            return Void.TYPE; 
        });  
        parser.registerFunction("entity.setequip", (sc, in) -> 
        { 
            EntityLivingBase liv = (EntityLivingBase) in[0].get(sc);  
            ItemStack stack = ((ItemStack) in[2].get(sc)).copy();
            switch(in[1].getString(sc))
            {
                case "hand":
                    liv.setItemStackToSlot(EntityEquipmentSlot.MAINHAND, stack);
                    return Void.TYPE;
                case "head":
                    liv.setItemStackToSlot(EntityEquipmentSlot.HEAD, stack);
                    return Void.TYPE;
                case "chest":
                    liv.setItemStackToSlot(EntityEquipmentSlot.CHEST, stack);
                    return Void.TYPE;
                case "legs":
                    liv.setItemStackToSlot(EntityEquipmentSlot.LEGS, stack);
                    return Void.TYPE;
                case "feet":
                    liv.setItemStackToSlot(EntityEquipmentSlot.FEET, stack);
                    return Void.TYPE;
                case "offhand":
                    liv.setItemStackToSlot(EntityEquipmentSlot.OFFHAND, stack);
            }
            return Void.TYPE; 
        }); 
        parser.registerFunction("entity.getequip", (sc, in) -> 
        { 
            EntityLivingBase liv = (EntityLivingBase) in[0].get(sc);        
            switch(in[1].getString(sc))
            {
                case "hand":
                    return liv.getItemStackFromSlot(EntityEquipmentSlot.MAINHAND);
                case "head":
                    return liv.getItemStackFromSlot(EntityEquipmentSlot.HEAD);
                case "chest":
                    return liv.getItemStackFromSlot(EntityEquipmentSlot.CHEST);
                case "legs":
                    return liv.getItemStackFromSlot(EntityEquipmentSlot.LEGS);
                case "feet":
                    return liv.getItemStackFromSlot(EntityEquipmentSlot.FEET);
                case "offhand":
                    return liv.getItemStackFromSlot(EntityEquipmentSlot.OFFHAND);
            }
            return ItemStack.EMPTY;
        });
        parser.registerFunction("entity.removeall", (sc, in) -> 
        { 
            Class<? extends Entity> c = (Class<? extends Entity>) getClass(in[0].getString(sc));
            if(c == Entity.class)
            {
                return Void.TYPE; 
            }
            Location l = (Location) in[1].get(sc);
            Utils.getEntities(l.getWorld(), l.getX(), l.getY(), l.getZ(), in[2].getDouble(sc), c).stream().forEach(ent -> 
            {
                ent.setDead();
            });
            return Void.TYPE; 
        });
        parser.registerFunction("entity.remove", (sc, in) -> 
        { 
            ((Entity) in[0].get(sc)).setDead(); 
            return Void.TYPE; 
        });
        parser.registerFunction("entity.setinvulnerable", (sc, in) -> 
        { 
            ((Entity) in[0].get(sc)).setEntityInvulnerable(in[1].getBoolean(sc)); 
            return Void.TYPE;
        });
        parser.registerFunction("entity.setsilent", (sc, in) -> 
        { 
            ((Entity) in[0].get(sc)).setSilent(in[1].getBoolean(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("entity.hide", (sc, in) -> 
        { 
            ((Entity) in[0].get(sc)).setInvisible(true); 
            return Void.TYPE; 
        });
        parser.registerFunction("entity.show", (sc, in) -> 
        { 
            ((Entity) in[0].get(sc)).setInvisible(false);
            return Void.TYPE; 
        });
        parser.registerFunction("entity.ride", (sc, in) -> 
        { 
            ((Entity) in[0].get(sc)).startRiding(((Entity) in[1].get(sc))); 
            return Void.TYPE; 
        });
        parser.registerFunction("entity.addeffect", (sc, in) -> 
        { 
            EntityLivingBase base = (EntityLivingBase) in[0].get(sc);
            Potion potion = Potion.getPotionFromResourceLocation(in[1].getString(sc));
            if(base == null) // doing this only to prevent EffectUtils.addPotionTo doing shit
            {
                throw new NullPointerException("null not allowed for entity");
            }
            else if(potion == null)
            {
                throw new NullPointerException("potion does not exist");
            }
            EffectUtils.addPotionTo(base, potion, in[2].getInt(sc), in[3].getInt(sc));
            return Void.TYPE; 
        });
        parser.registerFunction("entity.cleareffects", (sc, in) -> 
        { 
            ((EntityLivingBase) in[0].get(sc)).clearActivePotions();
            return Void.TYPE; 
        });
        parser.registerFunction("entity.haseffect", (sc, in) -> ((EntityLivingBase) in[0].get(sc)).isPotionActive(Potion.getPotionFromResourceLocation(in[1].getString(sc))));
        parser.registerFunction("entity.explode", (sc, in) -> 
        { 
            ((EntityCreeper) in[0].get(sc)).ignite(); 
            return Void.TYPE; 
        });
        parser.registerFunction("entity.spawnitemframe", (sc, in) -> 
        { 
            Location l = ((Location) in[0].get(sc));
            EntityItemFrame frame = new EntityItemFrame(l.getWorld(), l.getBlockPos(), EnumFacing.byName(in[1].getString(sc)));
            frame.setDisplayedItem(((ItemStack) in[2].get(sc))); // cppy happens in internals
            return Void.TYPE; 
        });
        parser.registerFunction("entity.getitemframe", (sc, in) -> ((EntityItemFrame) in[0].get(sc)).getDisplayedItem());
        parser.registerFunction("entity.get", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            return Utils.getEntity(l.getWorld(), l.getX(), l.getY(), l.getZ(), in[1].getDouble(sc), getClass(in[2].getString(sc)));
        });
        parser.registerFunction("entity.getpotiontype", (sc, in) -> PotionUtils.getPotionFromItem(((EntityPotion) in[0].get(sc)).getPotion()).getRegistryName().toString());
        parser.registerFunction("entity.setgravity", (sc, in) -> 
        { 
            ((Entity) in[0].get(sc)).setNoGravity(!in[1].getBoolean(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("entity.iswet", (sc, in) -> ((Entity) in[0].get(sc)).isWet());
        parser.registerFunction("entity.setpickupdelay", (sc, in) -> 
        { 
            ((EntityItem) in[0].get(sc)).setPickupDelay(in[1].getInt(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("entity.setage", (sc, in) -> 
        { 
            ReflectionUtils.setAge((EntityItem) in[0].get(sc), in[1].getInt(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("entity.spawn", (sc, in) -> 
        { 
            Location l = (Location) in[1].get(sc);
            World w = l.getWorld();
            BlockPos pos = l.getBlockPos();
            if(!w.isBlockLoaded(pos))
            {
                return false;
            }
           
            String type = in[0].getString(sc);
            double x = l.getX();
            double y = l.getY();
            double z = l.getZ();

            if (EntityList.LIGHTNING_BOLT.equals(new ResourceLocation(type)))
            {
                w.addWeatherEffect(new EntityLightningBolt(w, x, y, z, false));
            }
            else
            {
                NBTTagCompound nbttagcompound = new NBTTagCompound();
                boolean flag = false;

                if(in.length >= 3)
                {
                    try 
                    {
                        nbttagcompound = JsonToNBT.getTagFromJson(in[2].getString(sc));
                        flag = true;
                    }
                    catch(NBTException ex) 
                    {
                        return false;
                    }
                }

                nbttagcompound.setString("id", type);
                Entity entity = AnvilChunkLoader.readWorldEntityPos(nbttagcompound, w, x, y, z, true);
                if(entity == null)
                {
                    return false;
                }
                else
                {
                    entity.setLocationAndAngles(x, y, z, entity.rotationYaw, entity.rotationPitch);
                    if(!flag && entity instanceof EntityLiving)
                    {
                        ((EntityLiving) entity).onInitialSpawn(w.getDifficultyForLocation(new BlockPos(entity)), null);
                    }
                }
            }
            return true;
        });
        parser.registerFunction("entity.near", (sc, in) -> 
        {  
            Entity ent = (Entity) in[1].get(sc);
            in[0].set(sc, Utils.getLiving(ent, in[2].getDouble(sc))); 
            return Void.TYPE;
        });
        
        // ---------------------------------------------------------------------  
        // GMap-library   
        // ---------------------------------------------------------------------  
        parser.registerFunction("gmap.removeall", (sc, in) -> 
        {    
            final String map = in[0].getString(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.scripts.getDatabank().removeMap(map); 
            });
            return Void.TYPE; 
        });
        parser.registerFunction("gmap.add", (sc, in) -> 
        {    
            final String map = in[0].getString(sc);
            final String key = in[1].getString(sc);
            final String value = in[2].getString(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.scripts.getDatabank().addMapElement(map, key, value); 
            });
            return Void.TYPE; 
        });
        parser.registerFunction("gmap.remove", (sc, in) -> 
        {    
            final String map = in[0].getString(sc);
            final String key = in[1].getString(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.scripts.getDatabank().removeMapElement(map, key); 
            });
            return Void.TYPE; 
        });
        parser.registerFunction("gmap.get", (sc, in) -> KajetansMod.scripts.getDatabank().getMapValue(in[0].getString(sc), in[1].getString(sc)));
        parser.registerFunction("gmap.getordefault", (sc, in) -> 
        {
            Object o = KajetansMod.scripts.getDatabank().getMapValue(in[0].getString(sc), in[1].getString(sc));
            if(o == null)
            {
                return in[2].get(sc);
            }
            return o;
        });

        // ---------------------------------------------------------------------  
        // GDMap-library   
        // ---------------------------------------------------------------------  
        parser.registerFunction("gdmap.removeall", (sc, in) -> 
        {    
            if(in.length >= 2)
            {
                final String map = in[0].getString(sc);
                final String key = in[1].getString(sc);
                KajetansMod.scheduler.getWorker().add(() -> 
                {
                    KajetansMod.scripts.getDatabank().removeDualMapElement(map, key); 
                });
            }
            else
            {
                final String map = in[0].getString(sc);
                KajetansMod.scheduler.getWorker().add(() -> 
                {
                    KajetansMod.scripts.getDatabank().removeDualMap(map); 
                });
            }
            return Void.TYPE; 
        });
        parser.registerFunction("gdmap.add", (sc, in) -> 
        {    
            final String map = in[0].getString(sc);
            final String key1 = in[1].getString(sc);
            final String key2 = in[2].getString(sc);
            final String value = in[3].getString(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.scripts.getDatabank().addDualMapElement(map, key1, key2, value);  
            });
            return Void.TYPE; 
        });
        parser.registerFunction("gdmap.remove", (sc, in) -> 
        {    
            final String map = in[0].getString(sc);
            final String key1 = in[1].getString(sc);
            final String key2 = in[2].getString(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.scripts.getDatabank().removeDualMapElement(map, key1, key2); 
            });
            return Void.TYPE; 
        });
        parser.registerFunction("gdmap.get", (sc, in) -> 
        {    
            return KajetansMod.scripts.getDatabank().getDualMapValue(in[0].getString(sc), in[1].getString(sc), in[2].getString(sc)); 
        });
        parser.registerFunction("gdmap.getordefault", (sc, in) -> 
        {
            Object o = KajetansMod.scripts.getDatabank().getDualMapValue(in[0].getString(sc), in[1].getString(sc), in[2].getString(sc));
            if(o == null)
            {
                return in[3].get(sc);
            }
            return o;
        });

        // ---------------------------------------------------------------------  
        // Plot-library   
        // ---------------------------------------------------------------------  
        parser.registerFunction("plot.add", (sc, in) -> 
        {    
            final Location l1 = (Location) in[0].get(sc);
            final Location l2 = (Location) in[1].get(sc);
            final BlockPos pos1 = l1.getBlockPos();
            final BlockPos pos2 = l2.getBlockPos();
            final int x1 = pos1.getX();
            final int y1 = pos1.getY();
            final int z1 = pos1.getZ();
            final int x2 = pos2.getX();
            final int y2 = pos2.getY();
            final int z2 = pos2.getZ();
            final String world = ModDimensions.getWorldName(l1.getWorld());
            final String name = in[2].getString(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.plots.add(x1, y1, z1, x2, y2, z2, world, name);
            });
            return Void.TYPE;
        });
        parser.registerFunction("plot.remove", (sc, in) -> 
        {    
            final int plotId = in[0].getInt(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.plots.remove(plotId);
            });
            return Void.TYPE;
        });
        parser.registerFunction("plot.addplayer", (sc, in) -> 
        {    
            final int plotId = in[0].getInt(sc);
            final int playerId = in[1].getInt(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.plots.addPlayer(plotId, playerId);
            });
            return Void.TYPE;
        });
        parser.registerFunction("plot.removeplayer", (sc, in) -> 
        {    
            final int plotId = in[0].getInt(sc);
            final int playerId = in[1].getInt(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.plots.removePlayer(plotId, playerId);
            });
            return Void.TYPE;
        });
        parser.registerFunction("plot.getids", (sc, in) -> 
        {  
            Location l = (Location) in[0].get(sc);
            BlockPos pos = l.getBlockPos();
            return KajetansMod.plots.getIds(pos.getX(), pos.getY(), pos.getZ(), ModDimensions.getWorldName(l.getWorld())); 
        });
        parser.registerFunction("plot.canbuild", (sc, in) -> 
        {    
            Location l = (Location) in[0].get(sc);
            return KajetansMod.plots.canBuild(l.getWorld(), l.getBlockPos(), (EntityPlayer) in[1].get(sc));
        });
        parser.registerFunction("plot.getname", (sc, in) -> KajetansMod.plots.getName(in[0].getInt(sc)));
        parser.registerFunction("plot.doesintersect", (sc, in) -> 
        {    
            Location l = (Location) in[0].get(sc);
            BlockPos l1 = l.getBlockPos();
            BlockPos l2 = ((Location) in[1].get(sc)).getBlockPos();
            return KajetansMod.plots.isOverlapping(l1.getX(), l1.getY(), l1.getZ(), l2.getX(), l2.getY(), l2.getZ(), l.getWorld());
        });
        
        // ---------------------------------------------------------------------  
        // block protection library   
        // ---------------------------------------------------------------------  
        parser.registerFunction("protect.add", (sc, in) -> 
        {    
            final Location l1 = (Location) in[0].get(sc);
            final BlockPos pos1 = l1.getBlockPos();
            final int x1 = pos1.getX();
            final int y1 = pos1.getY();
            final int z1 = pos1.getZ();
            final int playerId = in[1].getInt(sc);
            final String world = ModDimensions.getWorldName(l1.getWorld());
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.blocks.getDatabank().add(x1, y1, z1, world, playerId);
            });
            return Void.TYPE;
        });
        parser.registerFunction("protect.remove", (sc, in) -> 
        {    
            final Location l1 = (Location) in[0].get(sc);
            final BlockPos pos1 = l1.getBlockPos();
            final int x1 = pos1.getX();
            final int y1 = pos1.getY();
            final int z1 = pos1.getZ();
            final String world = ModDimensions.getWorldName(l1.getWorld());
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.blocks.getDatabank().remove(x1, y1, z1, world);
            });
            return Void.TYPE;
        });
        parser.registerFunction("protect.addplayer", (sc, in) -> 
        {    
            final Location l1 = (Location) in[0].get(sc);
            final BlockPos pos1 = l1.getBlockPos();
            final int x1 = pos1.getX();
            final int y1 = pos1.getY();
            final int z1 = pos1.getZ();
            final String world = ModDimensions.getWorldName(l1.getWorld());
            final int playerId = in[1].getInt(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.blocks.getDatabank().addPlayer(x1, y1, z1, world, playerId);
            });
            return Void.TYPE;
        });
        parser.registerFunction("protect.removeplayer", (sc, in) -> 
        {    
            final Location l1 = (Location) in[0].get(sc);
            final BlockPos pos1 = l1.getBlockPos();
            final int x1 = pos1.getX();
            final int y1 = pos1.getY();
            final int z1 = pos1.getZ();
            final String world = ModDimensions.getWorldName(l1.getWorld());
            final int playerId = in[1].getInt(sc);
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.blocks.getDatabank().removePlayer(x1, y1, z1, world, playerId);
            });
            return Void.TYPE;
        });
        parser.registerFunction("protect.hasaccess", (sc, in) -> 
        {  
            Location l = (Location) in[0].get(sc);
            BlockPos pos = l.getBlockPos();
            return KajetansMod.blocks.getDatabank().hasAccess(pos, l.getWorld(), (EntityPlayer) in[1].get(sc));
        });
        parser.registerFunction("protect.getids", (sc, in) -> 
        {    
            Location l = (Location) in[0].get(sc);
            BlockPos pos = l.getBlockPos();
            return KajetansMod.blocks.getDatabank().getAllIds(pos.getX(), pos.getY(), pos.getZ(), ModDimensions.getWorldName(l.getWorld()));
        });
        
        // ---------------------------------------------------------------------  
        // Script-library   
        // ---------------------------------------------------------------------    
        parser.registerFunction("script.playerstolist", (sc, in) -> 
        {  
            in[0].set(sc, new ArrayList<>(KajetansMod.scripts.getPlayerList(sc.getId()))); 
            return Void.TYPE; 
        }); 
        parser.registerFunction("script.getplayeramount", (sc, in) -> (double) KajetansMod.scripts.getPlayerList(sc.getId()).size()); 
        parser.registerFunction("script.start", (sc, in) -> 
        {  
            Object o = in[0].get(sc);
            if(o instanceof EntityPlayer)
            {
                String[] names = new String[in.length - 1];
                for(int i = 1; i < in.length; i++)
                {
                    names[i - 1] = in[i].getString(sc);
                }
                return KajetansMod.scripts.startPlayerScript((EntityPlayer) in[0].get(sc), names);
            }
            String[] names = new String[in.length];
            names[0] = o.toString();
            for(int i = 1; i < in.length; i++)
            {
                names[i - 1] = in[i].getString(sc);
            }
            KajetansMod.scripts.startScript(names);
            return true;
        });
        parser.registerFunction("script.get", (sc, in) -> KajetansMod.scripts.getScript(in[0].getString(sc)));
        parser.registerFunction("script.join", (sc, in) -> KajetansMod.scripts.registerPlayer((Script) in[0].get(sc), (EntityPlayer) in[1].get(sc)));
        parser.registerFunction("script.kick", (sc, in) -> KajetansMod.scripts.unregisterPlayer(sc, (EntityPlayer) in[0].get(sc)));
        parser.registerFunction("script.getleader", (sc, in) -> 
        { 
            List<UUID> players = KajetansMod.scripts.getPlayerList(sc.getId());
            if(players.isEmpty())
            {
                return null;
            }
            return KajetansMod.server.getPlayerList().getPlayerByUUID(players.get(0));
        });

        // ---------------------------------------------------------------------  
        // Scoreboard-library   
        // ---------------------------------------------------------------------  
        parser.registerFunction("sb.add", (sc, in) -> 
        {  
            int id = in[1].getInt(sc);
            String message = SnuviUtils.connect(sc, in, 2);
            doForGroup(in[0].get(sc), sc, p -> ScoreboardUtils.get((EntityPlayerMP) p).addText(id, message));
            return Void.TYPE; 
        });
        parser.registerFunction("sb.remove", (sc, in) -> 
        {  
            int id = in[1].getInt(sc);
            doForGroup(in[0].get(sc), sc, p -> ScoreboardUtils.get((EntityPlayerMP) p).removeText(id));
            return Void.TYPE; 
        });
        parser.registerFunction("sb.reset", (sc, in) -> 
        {  
            doForGroup(in[0].get(sc), sc, p -> ScoreboardUtils.get((EntityPlayerMP) p).clear()); 
            return Void.TYPE; 
        });
        
        // ---------------------------------------------------------------------  
        // Display-library   
        // ---------------------------------------------------------------------  
        parser.registerFunction("display.add", (sc, in) -> 
        {  
            byte id = in[1].getByte(sc);
            String message = SnuviUtils.connect(sc, in, 2);
            doForGroup(in[0].get(sc), sc, p -> ModPacketHandler.sendToDisplay((EntityPlayerMP) p, (byte) 1, id, message));
            return Void.TYPE; 
        }); 
        parser.registerFunction("display.remove", (sc, in) -> 
        {  
            byte id = in[1].getByte(sc);
            doForGroup(in[0].get(sc), sc, p -> ModPacketHandler.sendToDisplay((EntityPlayerMP) p, (byte) 2, id, ""));
            return Void.TYPE; 
        });
        parser.registerFunction("display.reset", (sc, in) -> 
        {  
            doForGroup(in[0].get(sc), sc, p -> ModPacketHandler.sendToDisplay((EntityPlayerMP) p, (byte) 3, (byte) -1, "")); 
            return Void.TYPE; 
        });
        
        // ---------------------------------------------------------------------  
        // ItemStack-Display-library   
        // ---------------------------------------------------------------------  
        parser.registerFunction("stacks.set", (sc, in) -> 
        {  
            byte index = in[1].getByte(sc);
            if(index < 0 || index >= 9)
            {
                throw new IllegalArgumentException("index must be beetween 0 and 8, given: " + index);
            }
            int iconIndex = in[2].getInt(sc);
            int count = in[3].getInt(sc);
            doForGroup(in[0].get(sc), sc, p -> ModPacketHandler.setItemStackIndex((EntityPlayerMP) p, index, iconIndex, count));
            return Void.TYPE; 
        }); 
        parser.registerFunction("stacks.clearindex", (sc, in) -> 
        {  
            byte index = in[1].getByte(sc);
            if(index < 0 || index >= 9)
            {
                throw new IllegalArgumentException("index must be beetween 0 and 8, given: " + index);
            }
            doForGroup(in[0].get(sc), sc, p -> ModPacketHandler.setItemStackIndex((EntityPlayerMP) p, index, 0, 0));
            return Void.TYPE; 
        }); 
        parser.registerFunction("stacks.clear", (sc, in) -> 
        {  
            doForGroup(in[0].get(sc), sc, p -> ModPacketHandler.clearItemStacks((EntityPlayerMP) p));
            return Void.TYPE; 
        });
        parser.registerFunction("stacks.setactive", (sc, in) -> 
        {  
            boolean active = in[1].getBoolean(sc);
            doForGroup(in[0].get(sc), sc, p -> ModPacketHandler.setItemStackActive((EntityPlayerMP) p, active));
            return Void.TYPE; 
        });
        
        // ---------------------------------------------------------------------  
        // Head-library   
        // ---------------------------------------------------------------------  
        parser.registerFunction("head.add", (sc, in) -> 
        {  
            byte id = in[1].getByte(sc);
            String name = in[2].getString(sc);
            int x = in[3].getInt(sc);
            int y = in[4].getInt(sc);
            byte scale = in[5].getByte(sc);
            doForGroup(in[0].get(sc), sc, p -> ModPacketHandler.sendToHead((EntityPlayerMP) p, (byte) 1, id, name, x, y, scale));
            return Void.TYPE; 
        }); 
        parser.registerFunction("head.remove", (sc, in) -> 
        {  
            byte id = in[1].getByte(sc);
            doForGroup(in[0].get(sc), sc, p -> ModPacketHandler.sendToHead((EntityPlayerMP) p, (byte) 2, id, "", -1, -1, (byte) -1));
            return Void.TYPE; 
        });
        parser.registerFunction("head.reset", (sc, in) -> 
        {  
            doForGroup(in[0].get(sc), sc, p -> ModPacketHandler.sendToHead((EntityPlayerMP) p, (byte) 3, (byte) -1, "", -1, -1, (byte) -1));
            return Void.TYPE; 
        });
        
        // ---------------------------------------------------------------------  
        // Effect-library   
        // --------------------------------------------------------------------- 
        parser.registerFunction("effect.playsound", (sc, in) -> 
        { 
            Location l = (Location) in[0].get(sc);
            Vec3d v = l.getPos();
            EffectUtils.playSound((WorldServer) l.getWorld(), SoundEvent.REGISTRY.getObject(new ResourceLocation(in[1].getString(sc))), SoundCategory.MASTER, v.x, v.y, v.z);
            return Void.TYPE; 
        });
        parser.registerFunction("effect.play", (sc, in) -> 
        { 
            Location l = ((Location) in[0].get(sc));
            EffectUtils.spawnParticle((WorldServer) l.getWorld(), EnumParticleTypes.getByName(in[1].getString(sc)), l.getX() + 0.5, l.getY() + 0.5, l.getZ() + 0.5, in[2].getInt(sc));
            return Void.TYPE; 
        });

        // ---------------------------------------------------------------------  
        // Inventory-library   
        // ---------------------------------------------------------------------
        parser.registerFunction("inv.new", (sc, in) -> 
        { 
            in[0].set(sc, new SnuviInventory(in[2].getString(sc), in[1].getInt(sc), inventoryIds++)); 
            return Void.TYPE; 
        }); 
        parser.registerFunction("inv.newdynamic", (sc, in) -> 
        { 
            in[0].set(sc, new SnuviInventory(in[2].getString(sc), in[1].getString(sc), inventoryIds++)); 
            return Void.TYPE; 
        }); 
        parser.registerFunction("inv.getid", (sc, in) -> 
        { 
            return (double) ((SnuviInventory) in[0].get(sc)).getId(); 
        }); 
        parser.registerFunction("inv.loadblock", (sc, in) -> 
        { 
            Location l = (Location) in[1].get(sc);
            TileEntityChest chest = (TileEntityChest) l.getWorld().getTileEntity(l.getBlockPos());
            int size = chest.getSizeInventory();
            if(size % 9 != 0)
            {
                size /= 9;
                size++;
                size *= 9;
            }
            SnuviInventory inv = new SnuviInventory(in[2].getString(sc), size, inventoryIds++); 
            for(int i = 0; i < chest.getSizeInventory(); i++)
            {
                inv.setInventorySlotContents(i, chest.getStackInSlot(i).copy());
            }
            in[0].set(sc, inv); 
            return Void.TYPE; 
        });
        parser.registerFunction("inv.setitem", (sc, in) -> 
        { 
            ((IInventory) in[0].get(sc)).setInventorySlotContents(in[1].getInt(sc), (ItemStack) in[2].get(sc)); 
            return Void.TYPE; 
        });
        parser.registerFunction("inv.getitem", (sc, in) -> ((IInventory) in[0].get(sc)).getStackInSlot(in[1].getInt(sc)));
        parser.registerFunction("inv.open", (sc, in) -> 
        { 
            new ScriptInventoryHolder((SnuviInventory) in[0].get(sc), (EntityPlayerMP) in[1].get(sc), sc).openForPlayer(); 
            return Void.TYPE; 
        });
        parser.registerFunction("inv.close", (sc, in) -> 
        { 
            EntityPlayer p = (EntityPlayer) in[0].get(sc);
            if(p.openContainer instanceof CustomContainer)
            {
                ((CustomContainer) p.openContainer).closeSafe();
            }
            else
            {
                p.closeScreen();
            }
            return Void.TYPE; 
        });      
        parser.registerFunction("inv.update", (sc, in) ->  
        {
            EntityPlayerMP p = (EntityPlayerMP) in[0].get(sc);
            NonNullList<ItemStack> list = NonNullList.<ItemStack>create();
            int size = p.openContainer.inventorySlots.size();
            for(int j = 0; j < size; j++)
            {
                ItemStack itemstack = p.openContainer.inventorySlots.get(j).getStack();
                list.add(itemstack.isEmpty() ? ItemStack.EMPTY : itemstack);
            }
            p.sendAllContents(p.openContainer, list);
            return Void.TYPE; 
        }); 

        // ---------------------------------------------------------------------  
        // Read-library   
        // ---------------------------------------------------------------------
        parser.registerFunction("read.player", (sc, in) -> 
        {
            try
            {
                return Utils.getPlayerByName(in[0].getString(sc));
            }
            catch(PlayerNotFoundException ex)
            {
                return null;
            }
        });
        parser.registerFunction("read.location", (sc, in) -> new Location(in[0].getString(sc)));
        parser.registerFunction("read.item", (sc, in) -> 
        {
            String s = in[0].getString(sc);
            if(s.startsWith("{"))
            {
                String left = SnuviUtils.connect(sc, in, 1);
                return ItemStackUtils.getStackFromNbtString((s + left).replace('\'', '"'));
            }
            if(s.indexOf(':') == -1)
            {
                s = "minecraft:" + s;
            }
            Item item = ItemStackUtils.getItem(s);
            int amount = in.length >= 2 ? in[1].getInt(sc) : 1;
            int meta = in.length >= 3 ? in[2].getInt(sc) : 0;
            ItemStack stack = new ItemStack(item, amount, meta);
            if(in.length >= 4)
            {
                stack.setStackDisplayName(in[3].getString(sc));
            }
            if(in.length >= 5)
            {
                for(int i = 4; i < in.length; i++)
                {
                    ItemStackUtils.addLore(stack, in[i].getString(sc));
                }
            }
            return stack;
        });
        parser.registerFunction("read.spawnmob", (sc, in) -> NBTUtils.fromString(SnuviUtils.connect(sc, in, 1).replace('\'', '"'), (Location) in[0].get(sc)));

        // ---------------------------------------------------------------------  
        // Text-library   
        // ---------------------------------------------------------------------
        parser.registerFunction("text.location", (sc, in) -> ((Location) in[0].get(sc)).toString());
        parser.registerFunction("text.locationblock", (sc, in) -> ((Location) in[0].get(sc)).toBlockString());
        parser.registerFunction("text.item", (sc, in) -> ItemStackUtils.getNbtString((ItemStack) in[0].get(sc)));
        parser.registerFunction("text.click", (sc, in) -> NBTUtils.getClickable(in[0].get(sc), in[1].getString(sc)));
        parser.registerFunction("text.hover", (sc, in) -> NBTUtils.getHoverable(in[0].get(sc), in[1].getString(sc)));

        // ---------------------------------------------------------------------    
        // worker library
        // ---------------------------------------------------------------------  
        parser.registerFunction("worker.haswork", (sc, in) -> KajetansMod.scheduler.getWorker().hasWork());
        
        // ---------------------------------------------------------------------    
        // ban library
        // ---------------------------------------------------------------------  
        parser.registerFunction("ban.add", (sc, in) -> 
        {
            GameProfile gp = KajetansMod.server.getPlayerProfileCache().getProfileByUUID(getUUID(in[0].get(sc)));
            String reason = in[1].getString(sc);
            String banner = in[2].getString(sc);
            UserListBansEntry entry;
            if(in.length >= 4)
            {
                GregorianCalendar calender = (GregorianCalendar) in[3].get(sc);
                Date d = new Date(calender.getTimeInMillis());
                entry = new UserListBansEntry(gp, null, banner, d, reason);
            }
            else
            {
                entry = new UserListBansEntry(gp, null, banner, null, reason);
            }
            KajetansMod.server.getPlayerList().getBannedPlayers().addEntry(entry);
            return Void.TYPE;
        });
        parser.registerFunction("ban.remove", (sc, in) -> 
        {
            GameProfile gp = KajetansMod.server.getPlayerProfileCache().getProfileByUUID(getUUID(in[0].get(sc)));
            KajetansMod.server.getPlayerList().getBannedPlayers().removeEntry(gp);
            return Void.TYPE;
        });
        
        // ---------------------------------------------------------------------    
        // Ohne library
        // ---------------------------------------------------------------------   
        parser.registerFunction("getglobalvar", (sc, in) -> 
        {         
            Object o = in[0].get(sc);
            if(in.length == 2)
            {
                return KajetansMod.scripts.getDatabank().getVar(in[1].getString(sc), getUUID(o));
            }
            return KajetansMod.scripts.getDatabank().getVar(in[1].getString(sc), getUUID(o), in[2].get(sc));
        });
        parser.registerAlias("getglobalvar", "ggv");
        parser.registerFunction("setglobalvar", (sc, in) -> 
        { 
            final String value = in[2].getString(sc);
            final String var = in[1].getString(sc);
            final UUID uuid = getUUID(in[0].get(sc));
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.scripts.getDatabank().setVar(value, var, uuid);
            });
            return Void.TYPE; 
        });                          
        parser.registerAlias("setglobalvar", "sgv");
        parser.registerFunction("delglobalvar", (sc, in) -> 
        { 
            final String var = in[1].getString(sc);
            final UUID uuid = getUUID(in[0].get(sc));
            KajetansMod.scheduler.getWorker().add(() -> 
            {
                KajetansMod.scripts.getDatabank().deleteVar(var, uuid);
            });
            return Void.TYPE; 
        }); 
        parser.registerAlias("delglobalvar", "dgv");
        parser.registerFunction("msg", (sc, in) -> 
        { 
            sendMessageToGroup(in[0].get(sc), sc, NBTUtils.concat(sc, 1, in)); 
            return Void.TYPE; 
        });       
        parser.registerFunction("removeformat", (sc, in) -> SnuviUtils.connect(sc, in, 0).replaceAll("§.", ""));           
        parser.registerFunction("concatspace", (sc, in) -> SnuviUtils.connect(sc, in, " ", 0));     
        parser.registerFunction("onlyletters", (sc, in) -> 
        {             
            for(char c : SnuviUtils.connect(sc, in, 0).toCharArray())
            {
                if(!Character.isLetter(c))
                {
                    return false;
                }
            }
            return true;
        });
        parser.registerFunction("command", (sc, in) -> 
        { 
            final String s = SnuviUtils.connect(sc, in, 0);
            KajetansMod.scheduler.scheduleTask(() -> KajetansMod.server.commandManager.executeCommand(KajetansMod.server, s)); 
            return Void.TYPE;
        });
    }
    
    private static Class getClass(String s)
    {
        try
        {
            return Class.forName(s);
        }
        catch(ClassNotFoundException ex)
        {
            throw new IllegalStringException(s);
        }
    }
    
    private static IBlockState getBlockState(Location l)
    {
        return l.getWorld().getBlockState(l.getBlockPos());
    }

    private final static UUID SERVER_UUID = new UUID(0, 0);
    
    private static UUID getUUID(Object o)
    {
        if(o instanceof EntityPlayer)
        {
            return ((EntityPlayer) o).getUniqueID();
        }
        else if(o instanceof UUID)
        {
            return (UUID) o;
        }
        else if("SERVER".equals(o))
        {
            return SERVER_UUID;
        }
        return UUID.fromString(o.toString());
    }
    
    public static void doForGroup(Object group, Script sc, Consumer<ICommandSender> c)
    {
        if(group instanceof String)
        {
            switch(group.toString()) 
            {
                case "all":
                    PlayerList list = KajetansMod.server.getPlayerList();
                    KajetansMod.scripts.getPlayerList(sc.getId()).forEach(uuid -> 
                    {
                        EntityPlayerMP p = list.getPlayerByUUID(uuid);
                        if(p != null)
                        {
                            c.accept(p);
                        }
                    });
                    break;
                case "online":
                    KajetansMod.server.getPlayerList().getPlayers().forEach(p -> c.accept(p));
                    break;
                case "dev":
                    ChatChannel.getDevChannel().forEach((p) -> c.accept(p));
                    break;
                case "server":
                    c.accept(KajetansMod.server);
                    break;
                default:
                    c.accept(Utils.getPlayerByName(group.toString()));
                    break;
            }
            return;
        }
        c.accept((EntityPlayer) group);
    } 
    
    private static void sendMessageToGroup(Object group, Script sc, ITextComponent text)
    {
        doForGroup(group, sc, p -> p.sendMessage(text));
    }
}
